#version 120

#if defined(OPENGL_ES) || defined(GL_ES)
#ifdef GL_FRAGMENT_PRECISION_HIGH
precision highp float;
#else
precision mediump float;
#endif
#endif

///////////////////////////////////////////////////////////
// Uniforms
uniform float u_time;

///////////////////////////////////////////////////////////
// Variables
vec4 _baseColor;
///////////////////////////////////////////////////////////
// Varyings
varying vec2 v_texCoord;
varying vec4 v_color;


void main()
{
    vec2 uv=v_texCoord*2.0-1.0;
    gl_FragColor = vec4(_baseColor.rgb,(length(1.0-abs(uv))-1.0)*10.0);
    //gl_FragColor = vec4(vec3(1.0,0.0,0.0),(length(1.0-abs(uv))-1.0)*10.0);
}