#version 120

//wîƂƂ
#if defined(OPENGL_ES) || defined(GL_ES)
#ifdef GL_FRAGMENT_PRECISION_HIGH
precision highp float;
#else
precision mediump float;
#endif
#endif

//---uniform
uniform mat4 u_addMat;
uniform float u_time;
uniform float u_round;  //]ʁiJ̉]ɉj
//---Varyings
varying vec2 v_texCoord;

const float rsize=0.87;     //~̊TCY
const float width=0.06;     //g`̕
const float band=1000.0;    //~̕B傫قǍׂȂ
const float speed=0.2;      //u_timeɂėϓpx𒲐B傫قǂ܂߂ɕς
const float sharp=10.0;     //̕(ɂF̌)B傫قǍׂĂɂȂ
const vec3 baseCol=vec3(0.4,1.0,0.9);   //g̊F

const float PI = 3.14159;

//NX
float cross2(vec2 a, vec2 b){
    return a.x * b.y - a.y * b.x;
}
//hbg
float dot2(vec2 a, vec2 b){
    return a.x * b.x + a.y * b.y;
}
//Cӂ̃xNgxƂȂp𐳋KĕԂ
float ExAng(vec2 uv){
    float as = asin(uv.y/length(uv))*2.0/PI;
    float ang=  as * step(1.0, sign(uv.x)) 
          +(2.0-as)* (1.0-step(1.0,sign(uv.x)));
    return fract(ang*0.25);
}

//𐶐
float rnd(float p){
    return fract(sin(dot(vec2(p,floor(u_time*speed)),vec2(12.9898,78.233))) * 43758.5453);
}
//Ԃ𐶐(̓[v\Ƃ邽߂ɍőlo^)
float irnd(float p,float M){
    float ri = rnd(mod(ceil(p),M));
    float rf = rnd(mod(floor(p),M));
    return rf + (ri-rf)*fract(p);
}

void main(void) {
    float d;    //ėpϐ
    vec2 uv = v_texCoord.xy*2.0-1.0;
    float EA = mod(ExAng(uv)-0.25+u_round,1.0);//Xɑ΂px𐳋KlŕԂ̂A90ɉ񂷁i[ɂj

    //Wave
    float wave1 =irnd(EA*band,band);

    //ZWave(mat4:u_addMat(gpmatprm16ŗ^ꂽz)̒lɉWave𒵂˂)
    float wave2=0.0;
    float d_;
    for(float i=0.0;i<4.0;i++){
    for(float j=0.0;j<4.0;j++){
        d_=0.25*i+0.25*0.25*j;
        d=min(abs(-d_-1.0 - EA),
          min(abs(-d_+0.0 - EA),
              abs(-d_+1.0 - EA)));
        d=clamp(1.0-d*16.0,0.0,1.0);
        wave2+=15.0*d*u_addMat[int(j)][int(i)];
    }}
    
    //Wave
    float wave_=wave1*(1.0+wave2);   //ZWavel
    float wave =rsize+width*wave_;   //vZpɊgWavel

    //ݍWւ̃xNg̑傫ƁAWavȇ傫̍A`悷ׂF̔ZvZ
    d= abs(wave-length(uv));
    d= clamp(1.0-d*sharp,0.0,1.0);
    
    //gOWavelɉĐFω
    vec3 col2 = (baseCol+vec3(wave_*0.5,0.0,0.0))*d;

    //Xe[Wg̊O
    vec3 col3=vec3(1.0,1.0,1.0)*(-0.5*clamp(1.0-30.0*(length(uv)-0.9),0.0,1.0));

    //邮ƌZl
    vec3 col4=vec3(-0.8,-0.4,-0.4) *
              (1.0-clamp(abs(mod(0.02*u_time,1.0)-EA)*60.0,0.0,1.0));

    gl_FragColor = vec4(col2 + col3 + col4,1.0);
}