#version 120

#if defined(OPENGL_ES) || defined(GL_ES)
#ifdef GL_FRAGMENT_PRECISION_HIGH
precision highp float;
#else
precision mediump float;
#endif
#endif



///////////////////////////////////////////////////////////
// Uniforms
uniform float u_time;
uniform float flg_Vanish;

///////////////////////////////////////////////////////////
// Varyings
varying vec2 v_texCoord;

void main()
{
    vec2 uv=v_texCoord.xy;
    uv.x=1.0-uv.x*2.0;
    vec4 col = vec4(0.6,uv.xy*0.2+0.5,1.0);

    float xd = clamp(abs((mod(u_time,380.0) -200.0)/60.0 - uv.x)*10.0,0.0,1.0);
    float yd = clamp(abs((mod(u_time,400.0) -160.0)/60.0 - uv.y)*10.0,0.0,1.0);
    col.rgb-=0.5*xd*(mod(uv.y,0.2)-0.197);
    col.rgb-=0.5*yd*(mod(uv.x,0.2)-0.197);
    gl_FragColor=col;
    gl_FragColor.rgb *=(1.0-flg_Vanish); 
}
