#version 120

#if defined(OPENGL_ES) || defined(GL_ES)
#ifdef GL_FRAGMENT_PRECISION_HIGH
precision highp float;
#else
precision mediump float;
#endif
#endif

///////////////////////////////////////////////////////////
// Uniforms
uniform sampler2D u_diffuseTexture;
uniform float flg_Glay;
///////////////////////////////////////////////////////////
// Variables
vec4 _baseColor;
///////////////////////////////////////////////////////////
// Varyings
varying vec2 v_texCoord;

void main()
{
    //ItXN[obt@擾
    _baseColor = texture2D(u_diffuseTexture, v_texCoord);
    //flg_GlaỹtOŃO[XP[ɐ؂ւ
    gl_FragColor.rgb = (1.0-flg_Glay)*_baseColor.rgb
                     + flg_Glay*(_baseColor.r+_baseColor.g+_baseColor.b)*vec3(0.3,0.3,0.3);
    //~`ʂ
    float d=length( vec2(abs(v_texCoord.x-0.5)*2.0 , v_texCoord.y)-vec2(0.5,0.5) )*2.0;
    gl_FragColor.a=_baseColor.a*step(d,1.0);
}
