#version 120

//wiZp``

#if defined(OPENGL_ES) || defined(GL_ES)
#ifdef GL_FRAGMENT_PRECISION_HIGH
precision highp float;
#else
precision mediump float;
#endif
#endif
//---uniform
uniform float u_time;
uniform vec2 resolution;
//---others
vec2 uv;
const float size=15.0;

//sizeŕZp`^CŁAݍW}X̍Wi}XPʁjyт̃}X̒SWiKjVec4ŕԂ
vec4 getHexCoord(void){
    vec2 uv2=uv*vec2(1.0*sqrt(3.0),1.0)*size;
    vec2 inSq = vec2(floor(uv2.x/6.0),floor(uv2.y/2.0));
    vec2 fx = uv2 - (inSq*vec2(6.0,2.0)+vec2(3.0,1.0));
    float flg;
     flg = 8.0*step(0.0,fx.y-fx.x-2.0);//?
     flg+= 8.0*step(0.0,fx.y+fx.x-2.0);//E?
     flg+= 4.0*step(fx.y+fx.x+2.0,0.0);//?
     flg+= 4.0*step(fx.y-fx.x+2.0,0.0);//E?
     flg+= 1.0*step(0.0,fx.y);//?
     flg+= 2.0*step(0.0,fx.x);//E
    vec4 HexCoord;//?
     HexCoord.x=(inSq.x+0.5*step(4.0,flg)*(step(2.0,mod(flg,4.0))*2.0-1.0)+0.5)*2.0;
     HexCoord.y=inSq.y+mod(flg,2.0)*step(5.0,flg);
     HexCoord.z=HexCoord.x/size*sqrt(3.0);
     HexCoord.w=HexCoord.y/size*2.0 +mod(HexCoord.x ,2.0)/size;
    return HexCoord;
}
vec3 colBal(void){
    vec2 pos[3];
     pos[0]=vec2(2.0*sin(u_time*1.3+cos(u_time*0.1))-1.0,3.6*sin(u_time*0.2+cos(u_time*0.59+0.1))-1.8);
     pos[1]=vec2(2.0*sin(u_time*1.1+cos(u_time*0.2))-1.0,3.6*sin(u_time*0.3+cos(u_time*0.58+0.2))-1.8);
     pos[2]=vec2(2.0*sin(u_time*1.4+cos(u_time*0.3))-1.0,3.6*sin(u_time*0.4+cos(u_time*0.10+0.5))-1.8);
    float d[3];
    for(int i=0;i<=2;i++){
        d[i]=1.0-clamp(distance(getHexCoord().zw,pos[i])*0.5,0.0,1.0);
    }
    return vec3(d[0]+d[1],d[1]+d[2],d[2]+d[0]);
}

void main(void) {
    uv=(2.0*gl_FragCoord.xy - resolution)/min(resolution.x,resolution.y);
    float cVal=pow(1.0-length(getHexCoord().zw-uv),3.0) * (sin(u_time*0.9)-(sin(u_time*0.9)-0.5));
    gl_FragColor = vec4((0.8*colBal()+0.2)*cVal,1.0);
}