#version 120

///////////////////////////////////////////////////////////
// Atributes
attribute vec4 a_position;
attribute vec2 a_texCoord;

///////////////////////////////////////////////////////////
// Uniforms
uniform mat4 u_worldViewProjectionMatrix;
uniform float u_time;
///////////////////////////////////////////////////////////
// Varyings
varying vec2 v_texCoord;

void main()
{
    float d=length(a_position);
    vec2 xy=a_position.xy*(sin(d)+1.0)*sqrt(u_time/60.0);
    xy.y-=pow(1.01+0.003*d,clamp(u_time-20.0,0.0,40.0))-1.0;
    gl_Position = u_worldViewProjectionMatrix * vec4(xy,a_position.zw);
    v_texCoord = a_texCoord;
}
